#
# This file is part of GNU Enterprise.
#
# GNU Enterprise is free software; you can redistribute it
# and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2, or (at your option) any later version.
#
# GNU Enterprise is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with program; see the file COPYING. If not,
# write to the Free Software Foundation, Inc., 59 Temple Place
# - Suite 330, Boston, MA 02111-1307, USA.
#
# Copyright 2001-2002 Free Software Foundation
#
# FILE:
# TextUtils.py
#
# DESCRIPTION:
# Common text-related utilities
#
# NOTES:
#

import string 

# very simple lineWrap
def lineWrap(message,maxWidth):
  text = ""

  temptext = string.strip(str(message))

  for strings in string.split(temptext,"\n"):
    while len(strings) > maxWidth:
      index = 0
      for sep in [' ',',',':']:
        ind = string.rfind(strings,sep,0,maxWidth-1)+1
        if ind > index: index = ind

      if index > maxWidth:
        index = maxWidth-1

      text += "%s\n" % strings[:index]
      strings = strings[index:]

    text +=  "%s\n" % strings

  return text


def textToMeasurement(text, multiplier=1):
  # pt
  if text[-1] in ('0','1','2','3','4','5','6','7','8','9'):
    value = float(text) / 72 * multiplier
  else:
    unit = text[-2:]
    text = text[:-2]
    value = float(text) / {'pt':72, 'in':1, 'cm':2.54,
                           'mm': 25.4}[unit.lower()] * multiplier

  return value